#
# proto.rb
#
#   Copyright (c) 1999 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#

def printerr_full( err )
  print err.to_s, " (#{err.type})\n"
  err.backtrace.each{|i| puts i }
end


def protect( place = nil )
  begin
    ret = yield
  rescue
    puts 'Error in ' + place if place
    printerr_full $!
    nil
  end
  return ret
end
